      SUBROUTINE QSFPR(FUN,A,B,ABSERR,RELERR,T,RESULT,ERREST,NOFUN,
     1                 FLAG)
         INTEGER NOFUN
         REAL A,ABSERR,B,ERREST,FLAG,RELERR,RESULT,T
         COMPLEX FUN
         INTEGER I,J,LEV,LEVMAX,LEVMIN,LEVOUT,NIM,NOFIN,NOMAX
         REAL ALFA,AREA,BETA,C15,C16,C7,C8,COR11,CS,CS0,ESTERR,FI,FI0,
     1        FISAVE,FR,FR0,FRSAVE,GAMA,QDIFF,QLEFT,QNOW,QPREV,QRIGHT,
     2        S15,S16,S7,S8,SN,SN0,STEP,STONE,TA,TB,TC,TEMP,TOLERR,TT,
     3        X,X0,XSAVE
         COMPLEX F0,F1,FJ,ZI
         DIMENSION CS(16),FI(16),FISAVE(8,30),FR(16),FRSAVE(8,30),
     1             QRIGHT(31),SN(16),X(16),XSAVE(8,30)
       ZI = (0.,1.)
       LEVMIN = 1
       LEVMAX = 30
       LEVOUT = 6
       NOMAX = 5000
       NOFIN = NOMAX - 8*(LEVMAX - LEVOUT + 2**(LEVOUT + 1))
       FLAG = 0.
       RESULT = 0.0
       COR11 = 0.0
       ERREST = 0.0
       AREA = 0.0
       NOFUN = 0
       IF (A .EQ. B) GO TO 220
          LEV = 0
          NIM = 1
          X0 = A
          X(16) = B
          QPREV = 0.0
          F0 = FUN(X0)
          FR0 = F0
          FI0 = -ZI*FUN(X0)
          STONE = (B - A)/16.0
          X(8) = (X0 + X(16))/2.0
          X(4) = (X0 + X(8))/2.0
          X(12) = (X(8) + X(16))/2.0
          X(2) = (X0 + X(4))/2.0
          X(6) = (X(4) + X(8))/2.0
          X(10) = (X(8) + X(12))/2.0
          X(14) = (X(12) + X(16))/2.0
          DO 10 J = 2, 16, 2
             FJ = FUN(X(J))
             FR(J) = FJ
             FI(J) = -ZI*FJ
   10     CONTINUE
          NOFUN = 9
   20  CONTINUE
       X(1) = (X0 + X(2))/2.0
       F1 = FUN(X(1))
       FR(1) = F1
       FI(1) = -ZI*F1
       DO 30 J = 3, 15, 2
          X(J) = (X(J-1) + X(J+1))/2.0
          FJ = FUN(X(J))
          FR(J) = FJ
          FI(J) = -ZI*FJ
   30  CONTINUE
       NOFUN = NOFUN + 8
       STEP = (X(16) - X0)/16.0
       TT = T*STEP
       IF (TT .LE. 0.001) GO TO 40
          TA = SIN(2.*TT)
          TB = SIN(TT)
          TC = COS(TT)
          ALFA = (1. + TA/(2.*TT) - 2.*(TB/TT)**2)/TT
          BETA = 2.*(1. + TC**2 - TA/TT)/(TT**2)
          GAMA = 4.*(TB/TT - TC)/(TT**2)
          GO TO 50
   40  CONTINUE
       ALFA = 2.*(1./45. - (TT**2)/315. + (TT**4)/4725.)*TT**3
       BETA = 2.*(1./3. + (TT**2)*(1./15. - (2.*TT**2)/105. +
     1        (TT**4)/567.))
       GAMA = 4./3. - (TT**2)*(2./15. - (TT**2)/210. + (TT**4)/
     1        11340.)
   50  CONTINUE
       C8 = 0.
       S8 = 0.
       C7 = 0.
       S7 = 0.
       CS0 = COS(T*X0)
       SN0 = SIN(T*X0)
       DO 60 J = 1, 16
          CS(J) = COS(T*X(J))
          SN(J) = SIN(T*X(J))
   60  CONTINUE
       DO 70 J = 2, 6, 2
          C8 = C8 + FR(J)*CS(J)
          S8 = S8 + FI(J)*SN(J)
   70  CONTINUE
       C8 = C8 + (FR0*CS0 + FR(8)*CS(8))/2.
       S8 = S8 + (FI0*SN0 + FI(8)*SN(8))/2.
       C16 = 0.
       S16 = 0.
       DO 80 J = 10, 14, 2
          C16 = C16 + FR(J)*CS(J)
          S16 = S16 + FI(J)*SN(J)
   80  CONTINUE
       C16 = C16 + (FR(8)*CS(8) + FR(16)*CS(16))/2.
       S16 = S16 + (FI(8)*SN(8) + FI(16)*SN(16))/2.
       C7 = 0.
       S7 = 0.
       DO 90 J = 1, 7, 2
          C7 = C7 + FR(J)*CS(J)
          S7 = S7 + FI(J)*SN(J)
   90  CONTINUE
       C15 = FR(9)
       S15 = FI(9)*SN(9)
       DO 100 J = 11, 15, 2
          C15 = C15 + FR(J)*CS(J)
          S15 = S15 + FI(J)*SN(J)
  100  CONTINUE
       QLEFT = STEP*(ALFA*(FR(8)*SN(8) + FI(8)*CS(8) - FR0*SN0 -
     1         FI0*CS0) + BETA*(C8 - S8) + GAMA*(C7 - S7))
       QRIGHT(LEV+1) = STEP*(ALFA*(FR(16)*SN(16) + FI(16)*CS(16) -
     1                 FR(8)*SN(8) - FI(8)*CS(8)) + BETA*(C16 -
     2                 S16) + GAMA*(C15 - S15))
       QNOW = QLEFT + QRIGHT(LEV+1)
       QDIFF = QNOW - QPREV
       AREA = AREA + QDIFF
       ESTERR = ABS(QDIFF)/7.
       TOLERR = AMAX1(ABSERR,RELERR*ABS(AREA))*(STEP/STONE)
       IF (LEV .LT. LEVMIN) GO TO 110
          IF (LEV .GE. LEVMAX) GO TO 150
             IF (NOFUN .GT. NOFIN) GO TO 140
                IF (ESTERR .LE. TOLERR) GO TO 160
  110           CONTINUE
                NIM = 2*NIM
                LEV = LEV + 1
                DO 120 I = 1, 8
                   FRSAVE(I,LEV) = FR(I+8)
                   FISAVE(I,LEV) = FI(I+8)
                   XSAVE(I,LEV) = X(I+8)
  120           CONTINUE
                QPREV = QLEFT
                DO 130 I = 1, 8
                   J = -I
                   FR(2*J+18) = FR(J+9)
                   FI(2*J+18) = FI(J+9)
                   X(2*J+18) = X(J+9)
  130           CONTINUE
                GO TO 20
  140     CONTINUE
          NOFIN = 2*NOFIN
          LEVMAX = LEVOUT
          FLAG = FLAG + (B - X0)/(B - A)
          GO TO 160
  150  CONTINUE
       FLAG = FLAG + 1.0
  160  CONTINUE
       RESULT = RESULT + QNOW
       ERREST = ERREST + ESTERR
       COR11 = COR11 + QDIFF/7.
  170  CONTINUE
       IF (NIM .EQ. 2*(NIM/2)) GO TO 180
          NIM = NIM/2
          LEV = LEV - 1
          GO TO 170
  180  CONTINUE
       NIM = NIM + 1
       IF (LEV .LE. 0) GO TO 200
          QPREV = QRIGHT(LEV)
          X0 = X(16)
          FR0 = FR(16)
          FI0 = FI(16)
          DO 190 I = 1, 8
             FR(2*I) = FRSAVE(I,LEV)
             FI(2*I) = FISAVE(I,LEV)
             X(2*I) = XSAVE(I,LEV)
  190     CONTINUE
          GO TO 20
  200  CONTINUE
       RESULT = RESULT + COR11
       IF (ERREST .EQ. 0.) GO TO 220
  210  CONTINUE
       TEMP = ABS(RESULT) + ERREST
       IF (TEMP .NE. ABS(RESULT)) GO TO 220
          ERREST = 2.0*ERREST
          GO TO 210
  220  RETURN
      END
